100 REMark POINTER POSITION - Dilwyn Jones 2024
110 REMark BEEP if pointer at screen edges
120 REMark CTRL P to highlight cursor position
130 REMark CTRL Q to quit
140 :
150 REMark remove next line to compile for QDOS
160 JOB_NAME 'ptr_postn'
170 :
180 SPJOB -1,1 : REMark low priority background job
190 :
200 REMark configuration information
210 xdistance% = 20 : REMark beep this number of pixels from left/right
220 ydistance% = 10 : REMark and from top/bottom edges
230 sound_on%  = 1  : REMark beep or not at edges (1=yes,0=no)
240 pkey       = 16 : REMark CTRL P to highlight pointer
250 qkey       = 17 : REMark CTRL Q to qut from program
260 speed%     = 2  : REMark pause units between highlight circles
270 target_col = 7  : REMark pointer highlight circles colour
280 :
290 REMark get system variables address
300 sysvars = 163840 : REMark system variables on BBQL
310 v$ = VER$ : IF v$ = 'HBA' OR v$ = 'JSL1' THEN sysvars = VER$(-2)
320 :
330 REMark last key pressed system variable (sv_arbuf in QDOS)
340 sys_lchar = sysvars + 138
350 :
360 REMark sys_clnk system variable $C4 (dec. 196)
370 REMark pointer device driver definition block
380 con_linkage = PEEK_L(sysvars+196)
390 :
400 dw% = 512 : dh% = 256 : REMark BBQL default width/height
410 REMark get screen width/height from pt_xscrs/pt_yscrs
420 dw% = PEEK_W(con_linkage+242) : dh% = PEEK_W(con_linkage+244)
430 :
440 REMark define edge points for edge beeping
450 lx% = xdistance% : rx% = dw% - xdistance%
460 ty% = ydistance% : by% = dh% - ydistance%
470 :
480 pt_xpos = con_linkage + 60 : REMark $3C pt_xpos (pointer x position)
490 pt_ypos = con_linkage + 62 : REMark $3E pt_ypos (pointer y position)
500 :
510 oldx% = -1 : oldy% = -1 : REMark remember last position read
520 :
530 REPeat program
540   ptrx% = PEEK_W(pt_xpos) : REMark pointer x position
550   ptry% = PEEK_W(pt_ypos) : REMark pointer y position
560   :
570   IF ptrx% <> oldx% OR ptry% <> oldy% THEN
580     REMark pointer has moved from previous position
590     IF ptrx% < lx% OR ptrx% > rx% OR ptry% < ty% OR ptry% > by% THEN
600       REMark pointer near edge, so BEEP if set to do so
610       IF sound_on% THEN BEEP 5000,10
620     END IF
630     oldx% = ptrx% : oldy% = ptry%
640   END IF
650   :
660   key = PEEK_W(sys_lchar) : REMark last key pressed
670   SELect ON key
680     =qkey : EXIT program : REMark quit
690     =pkey : REMark highlight cursor position
700       Target ptrx%,ptry% : REMark highlight pointer origin
710       POKE_W sys_lchar,0 : REMark prevent targetting key repeat
720   END SELect
730 END REPeat program
740 :
750 REMark remove following line if compiling for QDOS
760 QUIT
770 :
780 STOP
790 :
800 DEFine PROCedure Target(x,y)
810   REMark draw circles around point x,y
820   REMark need to temporarily open a CON channel to draw
830   OPEN #0,'con_'&dw%&'x'&dh%&'a0x0'
840   :
850   REMark set SCALE to 1 pixel per graphic unit vertically
860   sclh = dh% : SCALE #0,sclh,0,0
870   :
880   pppy = 1 : REMark 1 pixel per scale point vertically
890   sclw = dw%/(1.35*dh%/sclh) : REMark no. of horizontal units
900   pppx = sclw/dw% : REMark points per pixels across
910   :
920   OVER #0,-1 : INK #0,target_col
930   FOR radius = 36 TO 2 STEP -2
940     CIRCLE #0,x*pppx,dh%-(y*pppy),radius
950     PAUSE speed% : REMark slight pause for viewing before erasing
960     CIRCLE #0,x*pppx,dh%-(y*pppy),radius : REMark erase circle
970   END FOR radius
980   OVER #0,0 : CLOSE #0
990 END DEFine Target
1000 :
1010 REMark $$off
1020 DEFine PROCedure Sa
1030   SAVE win1_ptrpostn_ptr_postn_bas : QSAVE win1_ptrpostn_ptr_postn
1040 END DEFine Sa
1050 REMark $$on
